C Vp.f
C
C VIS-5D function to calculate PERTURBATION v-wind (Vp)

C ==============================================================================

      INTEGER FUNCTION USERFUNC( OUTGRID, OUTNL, OUTLOWLEV,
     *                           INGRID, NR, NC, NL, LOWLEV, MAXNL,
     *                           NVARS, NAMES,
     *                           DATE, TIME,
     *                           PROJECTION, PROJ_ARGS,
     *                           VERTICAL, VERT_ARGS )
C ARGUMENTS:
      implicit none
      INTEGER NVARS
      INTEGER NR, NC, NL(NVARS), LOWLEV(NVARS), MAXNL
      REAL OUTGRID(NR,NC,MAXNL)
      INTEGER OUTNL, OUTLOWLEV
      REAL INGRID(NR,NC,MAXNL,NVARS)
      CHARACTER*8 NAMES(NVARS)
      INTEGER DATE, TIME
      INTEGER PROJECTION
      REAL PROJ_ARGS(*)
      INTEGER VERTICAL
      REAL VERT_ARGS(*)

C LOCAL VARS:
      integer var, ir, ic, il
      integer iv, ivm  

C ==============================================================================
      
C Specify number of levels in OUTGRID
      OUTNL = MAXNL
      OUTLOWLEV = 0
      
C Find the V and Vm variables (TOTAL and MEAN fields)
      iv = -1
      ivm = -1
      do var=1,nvars
        if (names(var) .eq. 'V') iv = var
        if (names(var) .eq. 'Vm') ivm = var        
      end do

C If V or Vm not found, return error 1
      if ( iv.eq.-1 .or. ivm.eq.-1 ) then
        print *, 
     $  "Couldn't find V or Vm vars!"
        userfunc = 1
        return
      endif

C ==============================================================================

C OUTPUT OF PERTURBATION V-WIND Vp (=V-Vm) 

      print*,
     $'Output of PERTURBATION v-wind Vp (m s-1)'
      DO 9999 ir=1,nr
      DO 9999 ic=1,nc
      DO 9999 il=1,maxnl
        outgrid(ir,ic,il)=ingrid(ir,ic,il,iv)-
     $                    ingrid(ir,ic,il,ivm)
9999  CONTINUE     

C ==============================================================================
               
      USERFUNC = 0
      RETURN
      END

C ==============================================================================
